]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Korrekturen im IDS System
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0t4" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 # ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 #ipfiremake linux XEN=1
340 ipfiremake linux
341 ipfiremake ipp2p
342 ipfiremake fcdsl
343 ipfiremake fcdsl2
344 ipfiremake fcdslsl
345 ipfiremake fcdslusb
346 ipfiremake fcdslslusb
347 # ipfiremake promise-sata-300-tx
348 ipfiremake zaptel
349 ipfiremake fuse
350 ipfiremake pkg-config
351 ipfiremake cpio
352 ipfiremake klibc
353 ipfiremake mkinitcpio
354 ipfiremake udev KLIBC=1
355 ipfiremake expat
356 ipfiremake gdbm
357 ipfiremake gmp
358 ipfiremake pam
359 ipfiremake openssl
360 ipfiremake curl
361 ipfiremake python
362 ipfiremake libnet
363 ipfiremake libjpeg
364 ipfiremake libpng
365 ipfiremake libtiff
366 ipfiremake libart
367 ipfiremake freetype
368 ipfiremake gd
369 ipfiremake popt
370 ipfiremake pcre
371 ipfiremake slang
372 ipfiremake newt
373 ipfiremake libcap
374 ipfiremake pciutils
375 ipfiremake usbutils
376 ipfiremake libxml2
377 ipfiremake libxslt
378 ipfiremake BerkeleyDB
379 ipfiremake mysql
380 ipfiremake cyrus-sasl
381 ipfiremake openldap
382 ipfiremake apache2
383 ipfiremake php
384 ipfiremake apache2 PASS=C
385 ipfiremake arping
386 ipfiremake beep
387 ipfiremake bind
388 ipfiremake capi4k-utils
389 ipfiremake cdrtools
390 ipfiremake dnsmasq
391 ipfiremake dosfstools
392 ipfiremake reiserfsprogs
393 ipfiremake squashfstools
394 ipfiremake sysfsutils
395 ipfiremake ntfs-3g
396 ipfiremake ethtool
397 ipfiremake ez-ipupdate
398 ipfiremake fcron
399 ipfiremake GD
400 ipfiremake GD-Graph
401 ipfiremake GD-TextUtil
402 ipfiremake gnupg
403 ipfiremake hdparm
404 ipfiremake ibod
405 ipfiremake initscripts
406 ipfiremake whatmask
407 ipfiremake iptables
408 ipfiremake libupnp
409 ipfiremake ipp2p IPT=1
410 ipfiremake moblock
411 ipfiremake linux-igd
412 ipfiremake ipac-ng
413 ipfiremake ipaddr
414 ipfiremake iptstate
415 ipfiremake iputils
416 ipfiremake l7-protocols
417 ipfiremake isdn4k-utils
418 ipfiremake mISDN
419 ipfiremake hwdata
420 ipfiremake kudzu
421 ipfiremake logrotate
422 ipfiremake logwatch
423 ipfiremake misc-progs
424 ipfiremake mtools
425 ipfiremake nano
426 ipfiremake nasm
427 ipfiremake URI
428 ipfiremake HTML-Tagset
429 ipfiremake HTML-Parser
430 ipfiremake Compress-Zlib
431 ipfiremake Digest
432 ipfiremake Digest-SHA1
433 ipfiremake Digest-HMAC
434 ipfiremake libwww-perl
435 ipfiremake Net-DNS
436 ipfiremake Net-IPv4Addr
437 ipfiremake Net_SSLeay
438 ipfiremake IO-Stringy
439 ipfiremake Unix-Syslog
440 ipfiremake Mail-Tools
441 ipfiremake MIME-Tools
442 ipfiremake Net-Server
443 ipfiremake Convert-TNEF
444 ipfiremake Convert-UUlib
445 ipfiremake Archive-Tar
446 ipfiremake Archive-Zip
447 ipfiremake Text-Tabs+Wrap
448 ipfiremake Locale-Country
449 ipfiremake XML-Parser
450 ipfiremake MP3-Info
451 ipfiremake MP3-Tag
452 ipfiremake glib
453 ipfiremake GeoIP
454 ipfiremake fwhits
455 ipfiremake noip_updater
456 ipfiremake ntp
457 ipfiremake openssh
458 ipfiremake openswan
459 ipfiremake pptpclient
460 ipfiremake rrdtool
461 ipfiremake setserial
462 ipfiremake setup
463 ipfiremake snort
464 ipfiremake snortsnarf
465 ipfiremake oinkmaster
466 ipfiremake squid
467 ipfiremake squid-graph
468 ipfiremake squidguard
469 ipfiremake calamaris
470 ipfiremake tcpdump
471 ipfiremake traceroute
472 ipfiremake vlan
473 ipfiremake wireless
474 ipfiremake libsafe
475 ipfiremake 3c5x9setup
476 ipfiremake pakfire
477 ipfiremake java
478 ipfiremake spandsp
479 ipfiremake lzo
480 ipfiremake openvpn
481 ipfiremake pammysql
482 ipfiremake ghostscript
483 ipfiremake cups
484 ipfiremake samba
485 ipfiremake sudo
486 ipfiremake mc
487 ipfiremake wget
488 ipfiremake bridge-utils
489 ipfiremake screen
490 ipfiremake hddtemp
491 ipfiremake smartmontools
492 ipfiremake htop
493 ipfiremake postfix
494 ipfiremake fetchmail
495 ipfiremake cyrusimap
496 ipfiremake webcyradm
497 ipfiremake mailx
498 ipfiremake clamav
499 ipfiremake spamassassin
500 ipfiremake amavisd
501 ipfiremake stund
502 ipfiremake libpri
503 # ipfiremake bristuff
504 ipfiremake asterisk
505 ipfiremake mpg123
506 ipfiremake mpfire
507 ipfiremake backup
508 ipfiremake libmad
509 ipfiremake libogg
510 ipfiremake libvorbis
511 ipfiremake lame
512 ipfiremake sox
513 ipfiremake gnump3d
514 ipfiremake libsigc++
515 ipfiremake applejuice
516 ipfiremake ocaml
517 ipfiremake mldonkey
518 ipfiremake libtorrent
519 ipfiremake rtorrent
520 ipfiremake ipfireseeder
521 ipfiremake rsync
522 ipfiremake tcpwrapper
523 ipfiremake portmap
524 ipfiremake nfs
525 ipfiremake nmap
526 ipfiremake mbmon
527 ipfiremake iftop
528 ipfiremake ncftp
529 ipfiremake cftp
530 ipfiremake etherwake
531 ipfiremake ethereal
532 ipfiremake tftp-hpa
533 ipfiremake bwm-ng
534 ipfiremake tripwire
535 ipfiremake sysstat
536 ipfiremake vsftpd
537 ipfiremake alsa
538 ipfiremake mp3blaster
539 ipfiremake which
540 ipfiremake lsof
541 }
542
543 buildinstaller() {
544 # Run installer scripts one by one
545 LOGFILE="$BASEDIR/log/_build.installer.log"
546 export LOGFILE
547 ipfiremake syslinux
548 ipfiremake as86
549 ipfiremake mbr
550 ipfiremake memtest
551 installmake linux-libc-header
552 installmake binutils
553 ipfiremake uClibc PASS=1
554 ipfiremake gcc INST=1
555 installmake uClibc PASS=2
556 installmake gcc INST=2
557 installmake uClibc PASS=3
558 installmake busybox
559 installmake udev
560 installmake slang
561 installmake newt
562 installmake gettext
563 installmake kbd
564 installmake popt
565 installmake sysvinit
566 installmake misc-progs
567 installmake e2fsprogs
568 installmake libaal
569 installmake reiser4progs
570 installmake reiserfsprogs
571 installmake sysfsutils
572 installmake util-linux
573 installmake pciutils
574 installmake zlib
575 installmake mtd
576 installmake wget
577 installmake hwdata
578 installmake kudzu
579 installmake installer
580 installmake initrd
581 }
582
583 buildpackages() {
584 LOGFILE="$BASEDIR/log/_build.packages.log"
585 export LOGFILE
586 echo "... see detailed log in _build.*.log files" >> $LOGFILE
587
588 installmake strip
589
590 # Generating list of packages used
591 echo -n "Generating packages list from logs" | tee -a $LOGFILE
592 rm -f $BASEDIR/doc/packages-list
593 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
594 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
595 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
596 fi
597 done
598 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
599 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
600 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
601 rm -f $BASEDIR/doc/packages-list
602 # packages-list.txt is ready to be displayed for wiki page
603 beautify message DONE
604
605 # Create images for install
606 if [ "$DEVEL" == "1" ]; then
607 ipfiremake cdrom ED=devel
608 fi
609 ipfiremake cdrom ED=full
610
611 # Check if there is a loop device for building in virtual environments
612 if [ -e /dev/loop0 ]; then
613 ipfiremake usb-stick
614 fi
615 ipfiremake pxe
616 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
617
618 ipfirepackages
619
620 # Cleanup
621 stdumount
622 rm -rf $BASEDIR/build/tmp/*
623
624 # Generating total list of files
625 echo -n "Generating files list from logs" | tee -a $LOGFILE
626 rm -f $BASEDIR/log/FILES
627 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
628 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
629 echo "##" >>$BASEDIR/log/FILES
630 echo "## `basename $i`" >>$BASEDIR/log/FILES
631 echo "##" >>$BASEDIR/log/FILES
632 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
633 fi
634 done
635 beautify message DONE
636
637 cd $PWD
638 }
639
640 ipfirepackages() {
641 ipfiredist alsa
642 # ipfiredist amavisd
643 ipfiredist applejuice
644 # ipfiredist asterisk
645 ipfiredist clamav
646 ipfiredist cups
647 ipfiredist cyrus-sasl
648 # ipfiredist fetchmail
649 # ipfiredist gnump3d
650 ipfiredist ipfireseeder
651 ipfiredist java
652 ipfiredist libogg
653 ipfiredist libvorbis
654 # ipfiredist mailx
655 # ipfiredist mldonkey
656 ipfiredist mp3blaster
657 ipfiredist mpfire
658 ipfiredist mpg123
659 # ipfiredist nfs
660 ipfiredist openldap
661 # ipfiredist postfix
662 ipfiredist rtorrent
663 ipfiredist samba
664 # ipfiredist sox
665 # ipfiredist spamassassin
666 ipfiredist tripwire
667 ipfiredist vsftpd
668 # ipfiredist webcyradm
669 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
670 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
671 rm -rf $BASEDIR/build/install/packages/*
672 }
673
674 # See what we're supposed to do
675 case "$1" in
676 build)
677 clear
678 BUILDMACHINE=`uname -m`
679 DEVEL=0
680 if [ "$2" == "--devel" ]; then
681 DEVEL=1
682 fi
683 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
684 #only restore on a clean disk
685 if [ ! -f log/cleanup-toolchain-2-tools ]; then
686 if [ ! -n "$PACKAGE" ]; then
687 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
688 prepareenv
689 buildtoolchain
690 else
691 PACKAGENAME=${PACKAGE%.tar.gz}
692 beautify build_stage "Packaged toolchain compilation"
693 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
694 tar zxf $PACKAGE
695 prepareenv
696 else
697 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
698 fi
699 fi
700 else
701 echo -n "Using installed toolchain" | tee -a $LOGFILE
702 beautify message SKIP
703 prepareenv
704 fi
705
706 beautify build_start
707 beautify build_stage "Building LFS"
708 buildbase
709
710 beautify build_stage "Building IPFire"
711 buildipfire
712
713 # Setzen des IPFire Builds
714 if [ "$FIREBUILD" ]; then
715 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
716 else
717 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
718 fi
719
720 beautify build_stage "Building installer"
721 buildinstaller
722
723 beautify build_stage "Building packages"
724 buildpackages
725 beautify build_end
726 ;;
727 shell)
728 # enter a shell inside LFS chroot
729 # may be used to changed kernel settings
730 prepareenv
731 entershell
732 ;;
733 changelog)
734 echo -n "Loading new Changelog from SVN: "
735 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
736 beautify message DONE
737 ;;
738 clean)
739 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
740 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
741 $LOSETUP -d $i 2>/dev/null
742 done
743 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
744 umount $i
745 done
746 stdumount
747 for i in `seq 0 7`; do
748 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
749 umount /dev/loop${i} 2>/dev/null;
750 losetup -d /dev/loop${i} 2>/dev/null;
751 fi;
752 done
753 rm -rf $BASEDIR/build
754 rm -rf $BASEDIR/cdrom
755 rm -rf $BASEDIR/packages
756 rm -rf $BASEDIR/log
757 if [ -h /tools ]; then
758 rm -f /tools
759 fi
760 beautify message DONE
761 ;;
762 downloadsrc)
763 if [ ! -d $BASEDIR/cache ]; then
764 mkdir $BASEDIR/cache
765 fi
766 mkdir -p $BASEDIR/log
767 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
768 FINISHED=0
769 cd $BASEDIR/lfs
770 for c in `seq $MAX_RETRIES`; do
771 if (( FINISHED==1 )); then
772 break
773 fi
774 FINISHED=1
775 cd $BASEDIR/lfs
776 for i in *; do
777 if [ -f "$i" -a "$i" != "Config" ]; then
778 echo -ne "Loading $i"
779 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
780 if [ $? -ne 0 ]; then
781 beautify message FAIL
782 FINISHED=0
783 else
784 if [ $c -eq 1 ]; then
785 beautify message DONE
786 fi
787 fi
788 fi
789 done
790 done
791 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
792 ERROR=0
793 for i in *; do
794 if [ -f "$i" -a "$i" != "Config" ]; then
795 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
796 if [ $? -ne 0 ]; then
797 echo -ne "MD5 difference in lfs/$i"
798 beautify message FAIL
799 ERROR=1
800 fi
801 fi
802 done
803 if [ $ERROR -eq 0 ]; then
804 echo -ne "${BOLD}all files md5sum match${NORMAL}"
805 beautify message DONE
806 else
807 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
808 beautify message FAIL
809 fi
810 cd - >/dev/null 2>&1
811 ;;
812 toolchain)
813 clear
814 prepareenv
815 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
816 buildtoolchain
817 BUILDMACHINE=`uname -m`
818 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
819 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
820 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
821 build/{bin,etc,usr/bin,usr/local} \
822 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
823 log >> $LOGFILE
824 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
825 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
826 stdumount
827 ;;
828 gettoolchain)
829 BUILDMACHINE=`uname -m`
830 # arbitrary name to be updated in case of new toolchain package upload
831 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
832 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
833 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
834 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
835 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
836 cd $BASEDIR/cache/toolchains
837 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
838 if [ $? -ne 0 ]; then
839 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
840 else
841 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
842 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
843 else
844 exiterror "$PACKAGE.md5 did not match, check downloaded package"
845 fi
846 fi
847 else
848 echo "Toolchain is already downloaded. Exiting..."
849 fi
850 ;;
851 othersrc)
852 prepareenv
853 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
854 chroot $LFS /tools/bin/env -i HOME=/root \
855 TERM=$TERM PS1='\u:\w\$ ' \
856 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
857 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
858 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
859 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
860 if [ $? -eq "0" ]; then
861 beautify message DONE
862 else
863 beautify message FAIL
864 fi
865 stdumount
866 ;;
867 svn)
868 case "$2" in
869 update|up)
870 # clear
871 echo -ne "Loading the latest source files...\n"
872 if [ $3 ]; then
873 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
874 else
875 svn update | tee -a $PWD/log/_build.svn.update.log
876 fi
877 if [ $? -eq "0" ]; then
878 beautify message DONE
879 else
880 beautify message FAIL
881 exit 1
882 fi
883 echo -ne "Writing the svn-info to a file"
884 svn info > $PWD/svn_status
885 if [ $? -eq "0" ]; then
886 beautify message DONE
887 else
888 beautify message FAIL
889 exit 1
890 fi
891 chmod 755 $0
892 exit 0
893 ;;
894 commit|ci)
895 clear
896 if [ -f /usr/bin/mcedit ]; then
897 export EDITOR=/usr/bin/mcedit
898 fi
899 if [ -f /usr/bin/nano ]; then
900 export EDITOR=/usr/bin/nano
901 fi
902 echo -ne "Selecting editor $EDITOR..."
903 beautify message DONE
904 if [ -e /sbin/yast ]; then
905 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
906 $0 changelog
907 fi
908 fi
909 update_langs
910 svn commit
911 $0 svn up
912 if [ -n "$FTP_CACHE_URL" ]; then
913 $0 uploadsrc
914 fi
915 ;;
916 dist)
917 if [ $3 ]; then
918 SVN_REVISION=$3
919 fi
920 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
921 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
922 exit 0
923 fi
924 echo -en "REV $SVN_REVISION: Downloading..."
925 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
926 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
927 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
928 evaluate 1
929
930 echo -en "REV $SVN_REVISION: Compressing files..."
931 if [ -e ipfire-source/trunk/make.sh ]; then
932 chmod 755 ipfire-source/trunk/make.sh
933 fi
934 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
935 evaluate 1
936 echo -en "REV $SVN_REVISION: Cleaning up..."
937 rm ipfire-source/ -r
938 evaluate 1
939 ;;
940 diff|di)
941 update_langs
942 echo -ne "Make a local diff to last svn revision"
943 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
944 evaluate 1
945 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
946 svn status
947 ;;
948 esac
949 ;;
950 uploadsrc)
951 PWD=`pwd`
952 cd $BASEDIR/cache/
953 echo -e "Uploading cache to ftp server:"
954 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
955 for i in *; do
956 if [ "$i" == "toolchains" ]; then continue; fi
957 grep -q $i /tmp/ftplist
958 if [ "$?" -ne "0" ]; then
959 echo -ne "$i"
960 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
961 if [ "$?" -ne "0" ]; then
962 beautify message FAIL
963 fi
964 fi
965 done
966 rm -f /tmp/ftplist
967 cd $PWD
968 exit 0
969 ;;
970 upload)
971 case "$2" in
972 iso)
973 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
974 cat <<EOF > .ftp-commands
975 mkdir -p $FTP_ISO_PATH$SVN_REVISION
976 ls -lah
977 quit
978 EOF
979 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
980 rm -f .ftp-commands
981 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
982 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso
983 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso.md5
984 if [ -e ipfire-$VERSION.$MACHINE-devel.iso ]; then
985 md5sum ipfire-$VERSION.$MACHINE-devel.iso > ipfire-$VERSION.$MACHINE-devel.iso.md5
986 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso
987 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso.md5
988 fi
989 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-source-r$SVN_REVISION.tar.gz
990 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ svn_status
991 if [ "$?" -eq "0" ]; then
992 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
993 else
994 echo -e "There was an error while uploading the iso to the ftp server."
995 exit 1
996 fi
997 if [ "$3" = "--with-sources-cd" ]; then
998 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
999 fi
1000 ;;
1001 paks)
1002 cat <<EOF > .ftp-commands
1003 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
1004 ls -lah
1005 quit
1006 EOF
1007 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
1008 rm -f .ftp-commands
1009 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
1010 if [ "$?" -eq "0" ]; then
1011 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1012 else
1013 echo -e "There was an error while uploading the packages to the ftp server."
1014 exit 1
1015 fi
1016 ;;
1017 esac
1018 ;;
1019 batch)
1020 if [ "$2" = "--background" ]; then
1021 batch_script
1022 exit $?
1023 fi
1024 if [ `screen -ls | grep -q ipfire` ]; then
1025 echo "Build is already running, sorry!"
1026 exit 1
1027 else
1028 if [ "$2" = "--rebuild" ]; then
1029 export IPFIRE_REBUILD=1
1030 echo "REBUILD!"
1031 else
1032 export IPFIRE_REBUILD=0
1033 fi
1034 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1035 screen -dmS ipfire $0 batch --background
1036 evaluate 1
1037 exit 0
1038 fi
1039 ;;
1040 watch)
1041 watch_screen
1042 ;;
1043 pxe)
1044 case "$2" in
1045 start)
1046 start_tftpd
1047 ;;
1048 stop)
1049 stop_tftpd
1050 ;;
1051 reload|restart)
1052 reload_tftpd
1053 ;;
1054 esac
1055 exit 0
1056 ;;
1057 lang)
1058 update_langs
1059 ;;
1060 packages)
1061 case "$2" in
1062 sign)
1063 sign_packages
1064 ;;
1065 esac
1066 ;;
1067 "")
1068 clear
1069 svn info
1070 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1071 do
1072 case $name in
1073 "IPFIRE: Downloadsrc")
1074 $0 downloadsrc
1075 ;;
1076 "IPFIRE: Build (silent)")
1077 $0 build-silent
1078 ;;
1079 "IPFIRE: Watch Build")
1080 $0 watch
1081 ;;
1082 "IPFIRE: Batch")
1083 $0 batch
1084 ;;
1085 "IPFIRE: Clean")
1086 $0 clean
1087 ;;
1088 "SVN: Update")
1089 $0 svn update
1090 ;;
1091 "Help")
1092 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1093 cat doc/make.sh-usage
1094 ;;
1095 "LOG: Tail")
1096 tail -f log/_*
1097 ;;
1098 "Exit")
1099 break
1100 ;;
1101 esac
1102 done
1103 ;;
1104 config)
1105 make_config
1106 ;;
1107 *)
1108 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1109 cat doc/make.sh-usage
1110 ;;
1111 esac